%% testFramework

%contains training and testing data;
%each feature vector is a ESF descriptor of one of 24 signs 
%of ASL alphaber
%Y is the corresponding letter
load('MLRFtest.mat');

Y = char2num(Y);
%split the training set
p = 0.2;
pcl = 0.5;
istest = rand(length(Y),1)<p;
%test set
Ytest = Y(istest);
Xtest = X(istest,:);
%train set
Ytrain = Y(~istest);
Xtrain = X(~istest,:);

%for clustering
iscluster = rand(length(Ytrain),1)<pcl;

YtrainCl = Ytrain(iscluster);
XtrainCl = Xtrain(iscluster,:);

YtrainNCl =  Ytrain(~iscluster);
XtrainNCl = Xtrain(~iscluster,:);

%clusters = ones(size(Y);
options.verbose = true;
options.normalize = 1; 
options.normalizeClusters = 1;
options.stdThr = 1e-4;
options.pathIsSet = 1; %RF path is defined
options.clusteringOnly = 0;

%% classification 0-level RF options
opts.depth = 15;
opts.numTrees= 10;
opts.numSplits= 5;
opts.verbose= true;
opts.classifierID= 2;

disp('Training 0-level forest with the following parameters: ');
disp(opts);

options.RFLevel0options = opts;
                
opts.depth = 10;
opts.numTrees= 10;
opts.numSplits= 5;
opts.verbose= true;
opts.classifierID= 2;

disp('Training 1-level forest with the following parameters: ');
disp(opts);

options.RFLevel1options = opts;

%% clustering RF options
clopts.depth= 5;
clopts.numTrees= 400;
clopts.numSplits= 5;
clopts.verbose= true;
clopts.classifierID= 2;
clopts.aggLevel = 4;
clopts.stdThr = options.stdThr;
clopts.small = 200;
clopts.K = 20;
clopts.distance = 'correlation';
clopts.mincpc = 100; %minimum number of classes pro cluster (in prozent?)
clopts.clnum = 20;
    
options.clusterOptions = clopts;


%% clustering
        
   

[clustersIni,~,maxclcount] = createClustersRF(XtrainCl,options.clusterOptions);   
chIniTr = confusionMatrix(clustersIni,YtrainCl);
clusters = cleanClustersExt(YtrainCl,clustersIni,chIniTr,options.clusterOptions);
chTr = confusionMatrix(clusters,YtrainCl);
clustersFinal = rearangeSmallClusters(YtrainCl,clusters,chTr,options.clusterOptions); 

Xfull = [XtrainCl; XtrainNCl];
Yfull = [YtrainCl; YtrainNCl];

[classifier,clusters,del] = train(Xfull,Yfull,clustersFinal,options);    

[Yt,Yclustering] = test(classifier,Xtest,options);

%show confusion matrix
bar3(confusionMatrix(Yt,Yclustering));

        