function [Yhard, Ysoft] = forestTest(model, X, opts)
    % X is NxD, where rows are data points
    % model comes from forestTrain()
    % Yhard are hard assignments to X's, Ysoft is NxK array of
    % probabilities, where there are K classes.
    
    %Ysoft is also a proximity matrix?
    
    warning('Using new (memsave) version of the forest');
    
    if nargin<3, opts= struct; end
    
    if (size(X,1)>10000 && nargout>2), warning('Too much training data for proximity matrix computation'); end;
    
    if(model.dim~=size(X,2)), error('training data dimensionality differs from test data dimensionality'); end;
    
    numTrees= length(model.treeModels);
    u= model.treeModels{1}.classes; % Assume we have at least one tree!
    Ysoft= zeros(size(X,1), length(u));
    
    opts.index = createIndex();
    
    opts.nosplitidx = model.nosplitidx;
    opts.mwIDidx = model.mwIDidx;

    for i=1:numTrees
        [~, ysoft] = treeTest(model.treeModels{i}, X, opts);
        Ysoft= Ysoft + ysoft;
    end
    
    Ysoft = Ysoft/numTrees;
    [~, ix]= max(Ysoft, [], 2);
    Yhard = u(ix);
end
